use serde::{Deserialize, Serialize};

#[derive(Serialize, Deserialize, Clone, Debug, PartialEq)]
pub enum ElementContent {
    Text(String),
}

impl TryFrom<ElementContent> for String {
    type Error = serde_json::Error;
    fn try_from(value: ElementContent) -> Result<Self, Self::Error> {
        match serde_json::to_string(&value) {
            Ok(s) => Ok(s),
            Err(e) => Err(e),
        }
    }
}

impl TryFrom<&str> for ElementContent {
    type Error = serde_json::Error;
    fn try_from(value: &str) -> Result<Self, Self::Error> {
        match serde_json::from_str(value) {
            Ok(ec) => Ok(ec),
            Err(e) => Err(e),
        }
    }
}
